// PipeLineFilters.cpp : Defines the entry point for the console application.
//

#include <stdio.h>
#include <string>
#include <sstream>
#include <iostream>
#include <iomanip>
#include <memory> //auto_ptr()
#include <assert.h>


//#include "plf_sys.h"
#include "progrcnt.h" 
#include "tests.h"


typedef int (*main_function)(int argc, char* argv[]);

struct TestNode
{
	std::string key_string;
	main_function fun;
};

TestNode list_of_tests[]={
	{"alexandresku",Tests::test_alexandresku},
	{"boost_mtr",Tests::test_boost_mtr}
};
static const int list_of_tests_size=sizeof(list_of_tests)/sizeof(list_of_tests[0]);



int main(int argc, char* argv[])
{
	try
	{
/*	
		std::cout << "Start test:" << std::endl;

		{
			for(int i=0; i<list_of_tests_size; ++i)
				std::cout << list_of_tests[i].key_string << std::endl;

			int current=list_of_tests_size-1;
			list_of_tests[current].fun(argc,argv);

		}
*/
//======== Test general purpose components ==============================================
//		return Tests::test_alexandresku(argc, argv);
//		return Tests::test_boost_mtr(argc, argv);
//		return Tests::test_Sscanf(argc, argv);
//		return Tests::test_meta_determinant(argc,argv);
//======== Test XML/INI files ===========================================================
//		return Tests::test_YWinIni(argc,argv);
//		return Tests::test_XML(argc,argv);
//		return Tests::test_DataString(argc,argv);
//		return Tests::test_yxml_learn(argc,argv);
//======== Test numerical methods components ==============================================
//		return Tests::test_spec_functions(argc,argv);
//		return Tests::test_Integral_Transforms(argc, argv);
//======== Test Pipe Line Filters========================================================
//		return Tests::test_plf_kernels(argc, argv);
//		return Tests::test_plf_StripBuffer(argc, argv);
//		return Tests::test_plf_IO_Ports(argc, argv);
//		return Tests::test_plf_system_idea(argc,argv);

//		return Tests::test_plf_Filter(argc, argv);
//		return Tests::test_plf_Filter_rgb(argc, argv);
//======== Test Image Algorithms Tools=====================================================
//		return Tests::test_alg_bresenham(argc,argv);
//		return Tests::test_color_spaces(argc, argv);
//		return Tests::test_fast_gauss(argc, argv);
//======== Test Image registration ========================================================
//		return Tests::test_image_registration_via_fft(argc,argv);
//		return Tests::test_color_registration(argc,argv);
//======== Satellite Image processing tests ========================================================
//		return TestsSat::sat_test_albedo(argc,argv);
//		return TestsSat::sat_test_fire(argc,argv);
//		return TestsSat::sat_test_stripe_registration(argc,argv);
//======== Experimental ========================================================
//		return Tests::test_gc2009(argc,argv);
/////		return Tests::test_vtl_ND_image(argc,argv);


//		return Tests::test_image_registration_via_oflow(argc,argv);
//======== Test Students ========================================================
//		return Tests::test_basics3D(argc,argv);

//		return Tests::test_line_curvature(argc,argv);
//		Tests::TestImgFromGrad(argc,argv);
//		Tests::TestEdgeDetectors(argc, argv);
//		Tests::TestEDT(argc, argv);
//		return Tests::TestDerivatives(argc, argv);

//		return Tests::test_wire_detection(argc,argv);
//		return Tests::test_color_blob(argc,argv);

//		return Tests::test_shadow_detection_hsi(argc, argv);
//		return Tests::test_shadow_detection_invariant(argc, argv);

		return Tests::test_curve_analysis(argc,argv);

//		return Tests::test_img_enhancement(argc,argv);
//		return Tests::test_medical_3d_image(argc,argv);

//		return 0;
	}
	catch(::AErrorStatusBase& msg)
	{
	std::cout << "Exception: "<< msg.Msg() << std::endl;
	}
	catch(std::string msg)
	{
		std::cout << "Exception: "<< msg << std::endl;
	}
	catch(const char * msg)
	{
		std::cout << "Exception: "<< msg << std::endl;
	};
	return 1;
}

