
#include "plf_functors.h"
#include "AbsDifference.h"

namespace Basics3D
{
	/////////////////////////////////////////////////////////////////////////////////////////
	C_AbsDifference::C_AbsDifference(const AImageMem8* in_im1,
																	 const AImageMem8* in_im2)
	{
		m_im1 = in_im1;
		m_im2 = in_im2;

		if (m_im1 == 0 || m_im2 == 0)
		{
			throw "\nOne of the src images was not recieved\n";
			return;
		}

		m_dif = dynamic_cast<AImageMem8 *>(::AImageCreate(0, AImage::IMGC_GRAYSCALE, 
														 m_im1->Width(), m_im1->Height(), m_im1->Bits()));

		if (m_dif == 0)
		{
			throw "\nCan't create difference image\n";
			return;
		}
	}

	/////////////////////////////////////////////////////////////////////////////////////////
	void C_AbsDifference::Apply()
	{
		Vtl::Plf::F21::AbsDif<AImageMem8::Pixel> func;
		Vtl::ImAlg::Tools::copy_2_1( 
					(*m_im1)[0], m_im1->Width(), m_im1->Height(), m_im1->NextLineShift(),
					(*m_im2)[0], m_im2->NextLineShift(),
					(*m_dif)[0], m_dif->NextLineShift(),
					func);
	}

	/////////////////////////////////////////////////////////////////////////////////////////
	void C_AbsDifference::Save(const char *in_filename)
	{
		::AImageSave(m_dif, in_filename, indicator);
	}

	///////////////////////////////////////////////////////////////////////////////////////////
	//C_AbsDifference::~C_AbsDifference()
	//{
	//	//m_dif->~AImageMem8();
	//}
}