
#include "Bracketing.h"

namespace Basics3D
{
	int zbrac(const IFunc *g,
						double *x1,
						double *x2)
	{
		if (*x1 == *x2)
		{
			throw "Bad initial range in zbrac";
			return 0;
		}

		double f1 = g->Func(*x1);
		double f2 = g->Func(*x2);

		for (int j = 0; j < NTRY; j++)
		{
			if (f1 * f2 < 0.0)
			{
				return 1;
			}

			if (fabs(f1) < fabs(f2))
			{
				*x1 += FACTOR * (*x1 - *x2);
				f1 = g->Func(*x1);
			}
			else
			{
				*x2 += FACTOR * (*x2-*x1);
				f2 = g->Func(*x2);
			}
		}
		return 0;
	}

	/////////////////////////////////////////////////////////////////////////////////////////
	/////////////////////////////////////////////////////////////////////////////////////////
	//Given a function fx dened on the interval from x1-x2 subdivide the interval into n equally
	//spaced segments, and search for zero crossings of the function. nb is input as the maximum number
	//of roots sought, and is reset to the number of bracketing pairs xb1[1..nb], xb2[1..nb]
	//that are found.
	//void zbrak(float (*fx)(float), float x1, float x2, int n, float xb1[], float xb2[], int *nb)
	//{
	//	int nbb,i;
	//	float x,fp,fc,dx;
	//	nbb=0;
	//	dx=(x2-x1)/n; //Determine the spacing appropriate to the mesh.
	//	fp=(*fx)(x=x1);
	//	//Loop over all intervals
	//	for (i=1;i<=n;i++)
	//	{
	//		fc=(*fx)(x += dx);
	//		//If a sign change occurs then record values for the bounds.
	//		if (fc*fp <= 0.0)
	//		{ 
	//			xb1[++nbb]=x-dx; 
	//			xb2[nbb]=x;
	//			if(*nb == nbb) return;
	//		}
	//		fp=fc;
	//	}
	//	*nb = nbb;
	//}
}