#ifndef DRAW_EPIPOLAR_LINES_H
#define DRAW_EPIPOLAR_LINES_H

// library includings
#include "aimage.h"
#include "consolap.h"
#include "alg_bresenham.h"
#include "num_linalg.h"

// own includings
#include "MatrixOperations.h"
#include "Points2DSet.h"
#include "Point2D.h"
#include "FundamentalMatrix.h"

namespace Basics3D
{
	class C_DrawEpipolarLines
	{
	private:
		const AImageMem8 *m_src0;
		const AImageMem8 *m_src1;
		AImageMemRgb8 *m_dst0;
		AImageMemRgb8 *m_dst1;
		
	public:
		C_DrawEpipolarLines(const AImageMem8 *in_src0,
			                  const AImageMem8 *in_src1);

		void Apply(const Vtl::NumAlg::Lin::ublas::c_matrix<double, 3, 3> &in_m,
							 const T_Points2DSet<C_Point2D> &in_points,
							 int i);

		void Save (const char *in_outputImageName,
		           const int in_i);

		void GetRandColor(int *r,
			                int *g,
										  int *b);

		void Ends(const Vtl::NumAlg::Lin::ublas::c_matrix<double, 3, 1> &in_Line,
		          const int in_h,
		          const int in_w,
			        int *out_x1,
					    int *out_y1,
              int *out_x2,
						  int *out_y2);

		void DrawLine(AImageMem8 *in_img,
		              const int in_nls,
			            const int in_col,
									const int in_x1,
									const int in_y1,
									const int in_x2,
									const int in_y2);

	};
}
#endif // DRAW_EPIPOLAR_LINES_H
