#ifndef ESSENTIAL_MATRIX_H
#define ESSENTIAL_MATRIX_H

// library includings
#include "num_linalg.h"

// own includings
#include "TransformMatrices.h"

namespace Basics3D
{
  void EssentialMatrix(Vtl::NumAlg::Lin::ublas::c_matrix<double, 3, 3> &out,
		                   const Vtl::NumAlg::Lin::ublas::c_matrix<double, 3, 3> &in_R,
											 const Vtl::NumAlg::Lin::ublas::c_vector<double, 3> &in_t);

	void EssentialMatrix(Vtl::NumAlg::Lin::ublas::c_matrix<double, 3, 3> &out,
		                   const Vtl::NumAlg::Lin::ublas::c_matrix<double, 3, 3> &in_F,
											 const Vtl::NumAlg::Lin::ublas::c_matrix<double, 3, 3> &in_K,
											 const Vtl::NumAlg::Lin::ublas::c_matrix<double, 3, 3> &in_K1);

	void SingularValues(double out_sv[2],
		                  const Vtl::NumAlg::Lin::ublas::c_matrix<double, 3, 3> &in);
}

#endif // ESSENTIAL_MATRIX_H
