
#include "Basics3D/Point2D.h"

namespace Basics3D
{
	/////////////////////////////////////////////////////////////////////////////////////////
	C_Point2D::C_Point2D(){}

	/////////////////////////////////////////////////////////////////////////////////////////
	C_Point2D::C_Point2D(double in_x,
											 double in_y,
											 int in_numb)
	{
		m_x = in_x;
		m_y = in_y;
		m_numb = in_numb;
	}

	///////////////////////////////////////////////////////////////////////////////////////
	double C_Point2D::X() const
	{
		return m_x;
	}

	/////////////////////////////////////////////////////////////////////////////////////////
	double C_Point2D::Y() const
	{
		return m_y;
	}

	/////////////////////////////////////////////////////////////////////////////////////////	
	int C_Point2D::Numb() const
	{
		return m_numb;
	}

	/////////////////////////////////////////////////////////////////////////////////////////
	void C_Point2D::SetNumb(const int i)
	{
	  m_numb = i;
	}

	/////////////////////////////////////////////////////////////////////////////////////////
	void C_Point2D::Matrix(Vtl::NumAlg::Lin::ublas::c_matrix<double, 3, 1> *out) const
	{
		out->operator()(0, 0) = m_x;
		out->operator()(1, 0) = m_y;
		out->operator()(2, 0) = 1;
	}

	/////////////////////////////////////////////////////////////////////////////////////////
	C_Point2D C_Point2D::operator = (const C_Point2D in_point)
	{
		m_x = in_point.X();
		m_y = in_point.Y();
		m_numb = in_point.Numb();

		return *this;
	}

	/////////////////////////////////////////////////////////////////////////////////////////
	void C_Point2D::Shift (double in_MeanX,
												 double in_MeanY)
	{
		m_x -= in_MeanX;
		m_y -= in_MeanY;
	}

	/////////////////////////////////////////////////////////////////////////////////////////
	void C_Point2D::Scale (double in_coef)
	{
		m_x *= in_coef;
		m_y *= in_coef;
	}

	/////////////////////////////////////////////////////////////////////////////////////////
	/*void C_Point2D::Load(T_Points2DSet<C_Point2D> &out_PointsSet,
		                   char *in_filename,
						           double in_t)
	{
		std::ifstream inFile;
		inFile.open(in_filename, std::ios::in);

		if (!inFile)
		{
			std::cerr << "Can't open " << in_filename << "\n";
			return;
		}

		float x1, y1, x2, y2, c, dist, distPrev;
		int numb = 0;
		int n;
		inFile >> n;

		for (int i = 0; i < n; i++)
		{
			inFile >> c;
			inFile >> dist;
			inFile >> distPrev;
			inFile >> c;
			inFile >> c;

			inFile >> x1;
			inFile >> y1;

			for (int j=0; j<130; j++)
			{
				inFile >> c;
			}

			inFile >> x2;
			inFile >> y2;

			for (int j=0; j<130; j++)
			{
				inFile >> c;
			}
			
			std::vector<C_Point2D> P;
			if (in_t * dist < distPrev)
			{
				P.push_back(C_Point2D(x1, y1, 2 * numb));
				P.push_back(C_Point2D(x2, y2, 2 * numb + 1));

				out_PointsSet.Add(P);

				numb++;
			}
		}

		inFile.close();
	}*/
	
	///////////////////////////////////////////////////////////////////////////////////////
	void C_Point2D::Print() const
	{
		std::cout << "\n" << m_x << "  " << m_y;
	}
}