#ifndef POINT2D_H_
#define POINT2D_H_

#include <iostream>

//library includings
#include "num_linalg.h"

namespace Basics3D
{
	class C_Point2D
	{
	protected:
		double m_x;
		double m_y;
		int m_numb;
		
	public:
		C_Point2D();

		C_Point2D(double in_x,
							double in_y,
							int in_numb);

		C_Point2D(std::ifstream inFile);

		double X() const;

		double Y() const;

		int Numb() const;

		void SetNumb(const int i);

		void Matrix(Vtl::NumAlg::Lin::ublas::c_matrix<double, 3, 1>* out) const;

		C_Point2D operator = (const C_Point2D in_point);

		void Shift (double in_MeanX,
								double in_MeanY);
		
		void Scale (double in_coef);

		void Print() const;
	};
}
#endif // POINT2D_H_
