
#include "Basics3D/Point2DParam.h"

namespace Basics3D
{
	//C_Point2DParam::C_Point2DParam(){};

	/////////////////////////////////////////////////////////////////////////////////////////
	C_Point2DParam::C_Point2DParam(double in_x,
																 double in_y,
																 int in_numb,
																 double in_sigma,
																 double in_angle,
																 const std::vector<float> &in_param)
	: C_Point2D(in_x, in_y, in_numb)
	{
		m_sigma = in_sigma;
		m_angle = in_angle;

		m_param.resize(m_paramNumb);

		for (int i=0; i < m_paramNumb; i++)
		{
			m_param[i] = in_param[i];
		}
	}

	
	/////////////////////////////////////////////////////////////////////////////////////////
	double C_Point2DParam::Distance(const C_Point2DParam &in_point) const
	{
		double dist = 0;

		for (int i = 0; i < m_paramNumb; i++)
		{
			dist += (m_param[i] - in_point.Param(i)) * (m_param[i] - in_point.Param(i));
		}

		return sqrt(dist);
	}

	/////////////////////////////////////////////////////////////////////////////////////////
	float C_Point2DParam::Param(int i) const
	{
		return m_param[i];
	}

	/////////////////////////////////////////////////////////////////////////////////////////
	//void C_Point2DParam::Load(T_Points2DSet<C_Point2DParam> &out_PointsSet,
	//	                        char *in_filename,
	//					                double in_t)
	//{
	//	std::ifstream inFile;
	//	inFile.open(in_filename, std::ios::in);

	//	if (!inFile)
	//	{
	//		std::cerr << "Can't open " << in_filename << "\n";
	//	}
	//	
	//	std::vector<float> param;
	//	param.resize(C_Point2DParam::ParamNumb());
	//	double x, y, sigma, angle;
	//	int c;
	//	int i = -1;
	//	
	//	while(1)
	//	{
	//		i++;

	//		inFile >> x;
	//		inFile >> y;
	//		inFile >> sigma;
	//		inFile >> angle;

	//		for (int j = 0; j < C_Point2DParam::ParamNumb(); j++)
	//		{
	//			inFile >> param[j];
	//		}

	//		std::vector<C_Point2DParam> P;
	//		P.push_back(C_Point2DParam(x, y, i, sigma, angle, &param));
	//		out_PointsSet.Add(P);
	//		
	//		c = inFile.peek();

	//		if (c == EOF)
	//		{
	//			break;
	//		}
	//	}

	//	inFile.close();

	//	//m_MeanX /= m_Points.size();
	//	//m_MeanY /= m_Points.size();
	//}
}