#ifndef POINTS_2D_PARARM_SET_H_
#define POINTS_2D_PARARM_SET_H_

#include <vector>
#include <fstream>
#include <iostream>

#include <vector>

// own includings
#include "Point2D.h"
#include "Point2DParam.h"
#include "Points2DSet.h"

namespace Basics3D
{
	class C_Points2DParamSet
	{
	private:
		std::vector<C_Point2DParam> m_Points;
		int m_groupSize;
		std::vector<double> m_MeanX;
		std::vector<double> m_MeanY;
		std::vector<double> m_MeanDev;

	private:
		double MeanX(int i);
		
		double MeanY(int i);

		double MeanDev(int i);

		void ClearMeans();
		
	public:
		C_Points2DParamSet(int i = 1);

		int Size() const;

		void Disable(T_Points2DSet<C_Point2D> &in_Set,
			           int j);

		void EnableAll();

		void Load(const char* in_filename,
			        const int in_imHeight);

		const C_Point2DParam* operator[](int i) const;

		void Normalize();

		//~C_Points2DParamSet();
	};
}
#endif // POINTS_2D_PARARM_SET_H_
