#include "Transform.h"

namespace Basics3D
{
	/////////////////////////////////////////////////////////////////////////////////////////
	C_Transform::C_Transform(const AImageMem8* in_src)
	{
		m_src = in_src;

		if (m_src == 0)
		{
			throw "\nSrc image was not recieved\n";
			return;
		}

		m_dst = dynamic_cast<AImageMem8 *>(::AImageCreate(0, AImage::IMGC_GRAYSCALE, 
													              m_src->Width(), m_src->Height(), m_src->Bits()));
		if (m_dst == 0)
		{
			throw "\nCan't create dst image\n";
			return;
		}
	}

	///////////////////////////////////////////////////////////////////////////////////////
	AImageMem8* C_Transform::Apply
		                        (const Vtl::NumAlg::Lin::ublas::c_matrix<double, 3, 3> &in_M)
	{
		if(indicator) indicator->start("Convert image", 0, 1);

		double M[9];

		for (int i = 0; i < 3; i++)
		{
			for (int j = 0; j < 3; j++)
			{
				M[i * 3 + j] = in_M(i, j);
			}
		}

		Vtl::ImAlg::Resamp::InterpBilinear<AImageMem8::Pixel> interp((*m_src)[0],
			     m_src->Width(), m_src->Height(), m_src->NextLineShift(),AImageMem8::Pixel(0));
		Vtl::ImAlg::Resamp::ProjectiveTransform(interp, M, 0, 0, 0, 0, (*m_dst)[0],
			                          m_dst->Width(), m_dst->Height(), m_dst->NextLineShift());

		if(indicator) indicator->finish();

		return m_dst;
	}

	/////////////////////////////////////////////////////////////////////////////////////////
	void C_Transform::Save(char* in_filename)
	{
		::AImageSave(m_dst, in_filename, indicator);
	}
	/////////////////////////////////////////////////////////////////////////////////////////
	//C_Transform::~C_Transform()
	//{
	//	//m_dst->~AImageMem8();
	//}
}