#ifndef TRANSFORM_H_
#define TRANSFORM_H_

// library includings
#include "consolap.h"
#include "aimage.h"
#include "imalg_tools.h"
#include "imalg_resampling.h"
#include "num_linalg.h"

// own includings
#include "MatrixOperations.h"

namespace Basics3D
{
	class C_Transform
	{
	private:
		const AImageMem8* m_src;
		AImageMem8* m_dst;

	public:
		//C_Transform();

		C_Transform(const AImageMem8* in_src);

		AImageMem8* Apply(const Vtl::NumAlg::Lin::ublas::c_matrix<double, 3, 3> &in_M);

		void Save(char* in_filename);

		//~C_Transform();
	};
}
#endif // TRANSFORM_H_
