#ifndef POINT_H
#define POINT_H

#include <iostream>

//library includings
#include "num_linalg.h"

namespace Vtl
{
namespace CurveDetection
{
	class Point
	{
	public:
		int x;
		int y;
		
	public:
		Point()
			:x(0), y(0) {}
    //-------------------------------------------------------------------------

		Point(int in_x,
					int in_y)
					: x(in_x), y(in_y) {}
		//-------------------------------------------------------------------------

		Point &operator= (const Point &p)
		{
			x = p.x;
			y = p.y;
			return (*this);
		}
		//-------------------------------------------------------------------------
		bool operator < (const Point &p) const
		{
		  double d1 = sqrt(double(x * x + y * y));
			double d2 = sqrt(double(p.x * p.x + p.y * p.y));
			return (d1 < d2);
		}
		//-------------------------------------------------------------------------

		double Dist(const Point &p) const
		{
		  double dx = x - p.x; 
			double dy = y - p.y;
			return sqrt(dx*dx + dy*dy);
		}

		//-------------------------------------------------------------------------
		void Print() const
		{
			std::cout << std::endl << x << "  " << y;
		}
	};
}
}
#endif // POINT_H