#ifndef BUILD_PALLETES_H
#define BUILD_PALLETES_H

// library includings
#include "aimage.h"

namespace Tests
{
	// Functions to build palletes of indexed colours

	/////////////////////////////////////////////////////////////////////////////
	inline void build_smooth_palette(AImage::Rgb* pal,
		                               int first,
																	 Pixel8 r1,
																	 Pixel8 g1,
																	 Pixel8 b1,
																	 int last,
																	 Pixel8 r2,
																	 Pixel8 g2,
																	 Pixel8 b2)
	{
		for(int i=first; i< last; ++i)
		{
			pal[i].r= Pixel8((r1*(last-i)+r2*(i-first))/double(last-first));
			pal[i].g= Pixel8((g1*(last-i)+g2*(i-first))/double(last-first));
			pal[i].b= Pixel8((b1*(last-i)+b2*(i-first))/double(last-first));
		}
	}

	/////////////////////////////////////////////////////////////////////////////
	inline void build_smooth_palette_spectra_2(AImage::Rgb* pal)
	{
		pal[0].r=pal[0].g=pal[0].b=0xFF/*0x00*/;
		int i1=1;
		int i2=(int)Vtl::Curvature::CurvatureScale<float>::radius_to_value(20);
		build_smooth_palette(pal, i1,0xFF,0x00,0xFF, i2,0xFF,0x00,0x00);//Magenta -> Red
		i1=i2;
		i2=(int)Vtl::Curvature::CurvatureScale<float>::radius_to_value(40);
		build_smooth_palette(pal, i1,0xFF,0x00,0x00, i2,0xFF,0xFF,0x00);// Red -> Yellow
		i1=i2;
		i2=(int)Vtl::Curvature::CurvatureScale<float>::radius_to_value(80);
		build_smooth_palette(pal, i1,0xFF,0xFF,0x00, i2,0x00,0xFF,0x00);// Yellow->Green
		i1=i2;
		i2=(int)Vtl::Curvature::CurvatureScale<float>::radius_to_value(160);
		build_smooth_palette(pal, i1,0x00,0xFF,0x00, i2,0x00,0xFF,0xFF);// Green -> Cyan
		i1=i2;
		i2=(int)Vtl::Curvature::CurvatureScale<float>::radius_to_value(320);
		build_smooth_palette(pal, i1,0x00,0xFF,0xFF, i2,0x00,0x00,0xFF);// Cyan -> Blue
		i1=i2;
		i2=255;
		build_smooth_palette(pal, i1,0x00,0x00,0xFF, i2,0x00,0x00,0x00);// Blue -> White
		pal[i2].r=pal[i2].g=pal[i2].b=0x00/*0xFF*/;
	}

	/////////////////////////////////////////////////////////////////////////////
	inline void build_smooth_palette_gray(AImage::Rgb* pal)
	{
		int i1=0;
		int i2=(int)Vtl::Curvature::CurvatureScale<float>::radius_to_value(5);
		build_smooth_palette(pal, i1,0xFF,0xFF,0xFF, i2,0xFA,0xFA,0xFA);//White(255) -> 250
		i1=i2;
		i2=(int)Vtl::Curvature::CurvatureScale<float>::radius_to_value(100);
		build_smooth_palette(pal, i1,0xFA,0xFA,0xFA, i2,0xAF,0xAF,0xAF);// 250 -> 175
		i1=i2;
		i2=(int)Vtl::Curvature::CurvatureScale<float>::radius_to_value(250);
		build_smooth_palette(pal, i1,0xAF,0xAF,0xAF, i2,0x32,0x32,0x32);// 175 -> 50
		i1=i2;
		i2=255;
		build_smooth_palette(pal, i1,0x32,0x32,0x32, i2,0x00,0x00,0x00);// 50 -> Black(0)
		pal[i2].r=pal[i2].g=pal[i2].b=0x00/*0xFF*/;
	}
} // namespace Tests


#endif // BUILD_PALLETES_H