#include <stdio.h>
#include <string>
#include <sstream>
#include <memory> //auto_ptr()
#include <assert.h>

//#include "aimage.h"
//#include "yfilesys.h"
//#include "consolap.h"

#include "plf_filters.h"
#include "tests.h"
namespace Tests
{
	static void printImageRef(Vtl::Plf::ImageRef<int>& ir, int id)
	{
		printf("------<%d>--------\n",id);
		for(int y=-ir.ext().before ; y<=ir.ext().forward; y++ )
		{
			printf("%c  ",(y==0)?'c':'-');
			int x=-ir.ext().left;
			for( ; x<0; x++)
				printf("%2d",ir[y][x]);
			printf(" | ");
			for( ; x<ir.w() ; x++)
				printf("%2d",ir[y][x]);
			printf(" | ");
			for( ; x < (ir.w()+ir.ext().right) ; x++)
				printf("%2d",ir[y][x]);
			printf("\n");
		}
	}

	int test_plf_IO_Ports(int argc, char* argv[])
	{
	/*
		std::auto_ptr<AImage> _in(::AImageLoad(0,true,argv[1],indicator));
		AImageMem8 *in=dynamic_cast<AImageMem8 *>(_in.get());
		if(in==0)
			return 1;
		const int w=in->Width();
		const int h=in->Height();
		const int bits=in->Bits();
		std::auto_ptr<AImage> _out(::AImageCreate(0,AImage::YImageClass::IMGC_GRAYSCALE,w,h,bits));
		AImageMem8 *out=dynamic_cast<AImageMem8 *>(_out.get());
		if(out==0)
			return 1;
	*/

		{
			//Vtl::Plf::PlfSrc_AImageMem8<float> src("src",in);
			//Vtl::Plf::PlfDst_AImageMem8<float> dst("dst",out);
			/*!
			 *     810, 
			 *       1,2,...,10.
			 */
			Vtl::Plf::ImgSize size(8,10);
			typedef Vtl::Plf::OutPort<int> OutPort_t;
			typedef Vtl::Plf::InPort<int>   InPort_t;
			OutPort_t outp;
			///   1  6
			outp.Init(0,0);
			///   2  6
			outp.set_bufferImgSize(size);

			InPort_t inp;
			inp.Init(0,0,Vtl::Plf::Extent(0,0,0,0));
			//inp.

			outp.ConnectTo(&inp);

			///   3  6
			outp.init_bufferExtents();
			///   4&5  6,       .
			outp.increase_delay_by(0);
			///   4&5  6,       .
			//outp.set_total_delay(0);
			///   6  6
			outp.init_buffer();

			while(inp.isFinished())
			{
				if(outp.isReadyForUpdate())
				{
					int y=outp.Y_wait();
					outp.beginUpdate();
					for( OutPort_t::Iter it=outp.begin() ; it!=outp.end() ; ++it )
					{
						*it=y;
					}
					outp.endUpdate();
				}
				if(inp.isDataReady())
				{
					Vtl::Plf::ImageRef<int> ir=inp.getImg();
					printImageRef(ir,inp.Y());
				}
			}
		}
	//	::AImageSave(out,argv[2],indicator);

		return 0;
	}
}//namespace Tests
