#include <stdio.h>
#include <algorithm>
#include <string>
//     
#include "aimage.h"
// !!!     bmp.h, ifloat.h, imagemem.h, 
// oz.h, pbm_file.h, tiff.h        . 
//   -   aimage.h.    
//    Windows    virtdib.h, zoomfact.h .

//        
#include "consolap.h"
template<typename T> class Negative
{
    T *pp;
    const T v;
    const int w;
    const int h;
    const int nls;
public:
     Negative(T *lefttop,int width, int height, int next_line_shift,T max_value)
    : pp(lefttop),w(width), h(height), nls(next_line_shift), v(max_value)
    {
    }
    void run(ProgressCounter* indicator)
    {
        T* p=pp;
        int d=nls-w;
        if(indicator) indicator->start(0,h-1,"Negative");
        for(int y=0; y<h; ++y)
        {
            //   
            int c=w;
            while(c--)
            {
                *p=v-(*p);
                ++p;
            }
            p+=d;
            if(indicator) 
                if(y&0x08) //     8 ,    ...
                    indicator->current(y);
        }
        if(indicator) indicator->finish();
    }
};

void Invert(Aimage *im,ProgressCounter* indicator=0)
{
        switch(im->GetImageStore())
        {
        case AImage::IMGS_AImageMem8:
        {
            AImageMem8* img=dynamic_cast<AImageMem8*>(im);
            if(img!=0)
            { 
                switch(img->ImageClass())
                {
                case AImage::IMGC_GRAYSCALE:
                { //  
                    int h=img->Height();
                    Negative<uint8_t> n((*img)[0],img->Width(),img->Height(),img->NextLineShift(),uint8_t((1<<img->Bits())-1));
                    n.run(indicator);
                }
                case AImage::IMGC_PALETTE:
                {//  ,   
                    const int n=img->GetPaletteEntries();
                    AImage::Rgb * pal=Palette();
                    for(int i=0; i<n; i++)
                    {
                        pal[i].r=255-pal[i].r;
                        pal[i].g=255-pal[i].g;
                        pal[i].b=255-pal[i].b;
                    }
                }
                default:
                    throw "Unsupported";
                };
            }
        }
        break;
        case AImage::IMGS_AImageMem16:
            {
                AImageMem16* img=dynamic_cast<AImageMem16*>(im);
                if(img!=0)
                { 
                    if(AImage::IMGC_GRAYSCALE==img->ImageClass())
                    { //  
                        int h=img->Height();
                        Negative<uint16_t> n((*img)[0],img->Width(),img->Height(),img->NextLineShift(),uint16_t((1<<img->Bits())-1));
                        n.run(indicator);
                    }
                }
            break;
        case AImage::IMGS_AImageMemRgb8:
        {
            AImageMemRgb8* img=dynamic_cast<AImageMemRgb8*>(im);
            if(img!=0)
            {
                //         (). TrueColor    
                //  3  - ,   . !      !   
                //   im.
                AImageMem8* r=img->GetPlane8(0);
                AImageMem8* g=img->GetPlane8(1);
                AImageMem8* b=img->GetPlane8(2);
                if(r!=0 && g!=0 && b!=0)
                {
                    Negative<uint8_t> nr((*r)[0],r->Width(),r->Height(),r->NextLineShift(),uint8_t((1<<r->Bits())-1));
                    Negative<uint8_t> ng((*g)[0],g->Width(),g->Height(),g->NextLineShift(),uint8_t((1<<g->Bits())-1));
                    Negative<uint8_t> nb((*b)[0],b->Width(),b->Height(),b->NextLineShift(),uint8_t((1<<b->Bits())-1));
                    nr.run(indicator);
                    ng.run(indicator);
                    nb.run(indicator);
                }
            }
        }
        break;
        default:
            printf("Unsupported!\n");
        };
}

int main(int argc, char* argv[])
{
    if(argc!=3)
    {
        printf("Command string:\n test.exe input_img output_img\n");
        return 1;
    }
    try
    {
        //  . !       - 
        //  .      ,        .
        //       auto_ptr,  ++ ,       
        //   ,        .
        std::auto_ptr<AImage> _im(::AImageLoad(0,true,argv[1],indicator));
        // auto_ptr   ,        -     .
        AImage* im=_im.get();
        Invert(im,indicator); //  
        ::AImageSave(im,argv[2],indicator); // indicator -           .
    }
    catch(AErrorStatusBase& msg )
    {
        printf("Exception: \nIn class %s\n In Derived class %s\n IN file %s line:%d\n Error message%s\n",
			msg.ClassName(),msg.DerivedClassName(),msg.File(),msg.Line(),msg.Msg());
        //printf("Exception: %s\n",msg.Msg());
    }
    catch(std::string msg)
    {
        printf("Exception: %s\n",msg.c_str());
    }
    catch(const char *msg)
    {
        printf("Exception: %s\n",msg);
    }
    return 0;
}

