#include <sys\stat.h> //S_IWRITE, S_IREAD

#include <sys\types.h> //struct stat
#include <time.h>

#include <io.h>
#include <fcntl.h>
#include <stdarg.h>//va_start,va_end,va_list
#include <stdio.h>//SEEK_SET
#include <string.h>//::strlen(), ::strcat()
#pragma hdrstop
#include "loki_static_check.h"
#include "yfile.h"
#include "yfilesys.h"

//#################################################
//#################################################
//#################################################
//virtual 
bool YFile::IsOk() const 
{ 
	int * handle_=(int *)(&handle);
	return (*handle_) != -1; 
}

YFile::YFile()
{
	int * handle_=(int *)(&handle);
	*handle_=-1;
	mode=UIO_UNKNOWN;
}

//virtual
YFile::~YFile()
{
	LOKI_STATIC_CHECK(sizeof(int)<=sizeof(handle),Array_handle_in_file_yfile_h_is_too_small_to_save_HANDLE_type__Increase_it);
	_close();
}

int YFile::_open(const char * szFileName,OpenMode access)
{
	_close();
	int * handle_=(int *)(&handle);
	mode=access;
	switch(access)
	{
	case UIO_CREATE:
			*handle_ = ::_open(szFileName, O_CREAT | O_BINARY | O_EXCL  | O_RDWR , S_IWRITE | S_IREAD  );
			break;
	case UIO_CREATE_OVERWRITE:
			*handle_ = ::_open(szFileName, O_CREAT | O_BINARY | O_TRUNC | O_RDWR , S_IWRITE | S_IREAD  );
			break;
	case UIO_RDONLY:
			*handle_ = ::_open(szFileName, O_BINARY | O_RDONLY);
			break;
	case UIO_MODIFY:
			*handle_ = ::_open(szFileName, O_BINARY | O_RDWR	, S_IWRITE | S_IREAD );
			break;
	default:
			*handle_=-1;
			mode=UIO_UNKNOWN;
	};
	if (*handle_ == -1)
	{
		return -1;//errFileOpen; // Error open
	}
	return 0;
}

int YFile::_close()
{
	int * handle_=(int *)(&handle);
	if(*handle_!=-1)
	{
		::_close(*handle_);
		*handle_=-1;
		mode=UIO_UNKNOWN;
	}
	return 0;
}

int YFile::_read(int64_t pos,void *data,int len)
{
	int * handle_=(int *)(&handle);
	if(*handle_!=-1)
	{
		::_lseeki64(*handle_,pos,SEEK_SET);
		return ::_read(*handle_,data,len);
	}
	return -1;
}

int YFile::_write(int64_t pos,const void *data,int len)
{
	int * handle_=(int *)(&handle);
	if(*handle_!=-1)
	{
		::_lseeki64(*handle_,pos,SEEK_SET);
		return ::_write(*handle_,data,len);
	}
	return -1;
}
//#################################################
//#################################################
//#################################################
void YFileRead::constructor(const char *filename)
{
	int * handle_=(int *)(&handle);
	*handle_ = ::_open(filename,O_RDONLY|O_BINARY);
	if(*handle_ == -1 )
	{
		throw "can't open file for read";
	}
}

//virtual
YFileRead::~YFileRead()
{
	_close();
}
void YFileRead::_close()
{
	int * handle_=(int *)(&handle);
	if(*handle_ != -1 )
	{
		::_close(*handle_);
		*handle_=-1;
	}
}
void YFileRead::SetPosition(int64_t offset)
{
	int * handle_=(int *)(&handle);
	::_lseeki64(*handle_,offset,SEEK_SET);
}
int YFileRead::read(void* data,int len)
{
	int * handle_=(int *)(&handle);
	return ::_read(*handle_,data,len);
}
int YFileRead::read(int64_t offset,void* data,int len)
{
	int * handle_=(int *)(&handle);
	::_lseeki64(*handle_,offset,SEEK_SET);
	return ::_read(*handle_,data,len);
}
int64_t YFileRead::GetFileSize()
const
{
	int * handle_=(int *)(&handle);
	struct _stati64  stat;
	if(0==::_fstati64( *handle_, &stat))
		return stat.st_size;
	return 0;
}

YDataTime YFileRead::GetTime()
const
{
	int * handle_=(int *)(&handle);
	struct _stat buffer;
	if(0==::_fstat( *handle_, &buffer))
	{
		tm * t = gmtime(&buffer.st_mtime); 
		if(t)
			return  YDataTime(t->tm_year+1900,t->tm_mon+1,t->tm_mday,t->tm_hour,t->tm_min,t->tm_sec);
	}
	return YDataTime();
}

//#################################################
//#################################################
//#################################################
void YFileWrite::constructor(const char *filename)
{
	int * handle_=(int *)(&handle);
	*handle_ = ::_open(filename,O_RDWR|O_BINARY|O_TRUNC|O_CREAT,S_IREAD|S_IWRITE);
//	printf("Open File %s *handle_=0x%08X\n",filename,*handle_);
	if(*handle_ == -1 )
	{
		throw "can't create file";
	}
}
//virtual
YFileWrite::~YFileWrite()
{
	_close();
}

void YFileWrite::_close()
{
	int * handle_=(int *)(&handle);
	if(*handle_ != -1 )
	{
		::_close(*handle_);
		*handle_=-1;
	}
}

void YFileWrite::SetPosition(int64_t offset)
{
	int * handle_=(int *)(&handle);
	::_lseeki64(*handle_,offset,SEEK_SET);
}
int64_t YFileWrite::GetPosition()
{
	int * handle_=(int *)(&handle);
	return ::_telli64(*handle_);
}
int YFileWrite::write(const void* data,int len)
{
	int * handle_=(int *)(&handle);
	return ::_write(*handle_,data,len);
}
int YFileWrite::write(int64_t offset,const void* data,int len)
{
	int * handle_=(int *)(&handle);
	::_lseeki64(*handle_,offset,SEEK_SET);
	return ::_write(*handle_,data,len);
}
///////////////////////////////////////////////////////////
// class DebugToFile provides overloaded class DebugBase
// function printf() for debug print to file
///////////////////////////////////////////////////////////
DebugToFile::DebugToFile()
:DebugBase()
{
	fp_debug=0;
}
DebugToFile::~DebugToFile()
{
	DebugToFile::Close();
}
void DebugToFile::Init(const char* fname)
{
	DebugToFile::Close();
	if(fname)
	{
		debug_fname=fname;
	}
	if(debug_fname.length()>0)
	{
		fp_debug=::fopen(debug_fname.c_str(),"wt");
	}
}
//virtual
void DebugToFile::Close()
{
	if(debug_fname.length()>0)
	{
		debug_fname="";
	}
	if(fp_debug)
	{
		::fclose((FILE*)fp_debug);
		fp_debug=0;
	}
}
//virtual
int DebugToFile::printf(const char *format,...)
const
{
	if(fp_debug)
	{
		va_list argptr;
		va_start(argptr, format);
		//char buf[1024];
		//int count=::vsprintf(buf,format,argptr);
		int count=::vfprintf((FILE*)fp_debug,format,argptr);
		va_end(argptr);
		return count;
	}
	return 0;
}

/*
///////////////////////////////////////////////////////////
// class YFileName contains ONLY STATIC FUNCTIONS
// to make some job on file/directory names and pathes.
///////////////////////////////////////////////////////////
//static
bool YFileName::IsFileExist(const char* path)
{
	return YFileSys::isFileExist(path?path:"");
}
//static
unsigned long YFileName::GetFileSize(const char* path)
{
	struct stat buffer;
	if(0==::stat(path,&buffer))
		return buffer.st_size;
	return 0;
}
//static
bool YFileName::IsFullName(const char* path)
{
	if(!path)
		throw "YFileName::IsFullName() : null path";
	if(::strlen(path)<3)
		return false;
	if(path[1]==':')
		return true;
	return false;
}
//static
bool YFileName::HasWildCards(const char* path)
{
	if(!path)
		throw "YFileName::IsFullName() : null path";
	while(*path)
	{
		if(*path=='*' || *path=='?' )
			return true;
		path++;
	}
	return false;
}
//static
const char * YFileName::GetExt(const char* path)
{//ext=".tiff"
	if(!path )
		throw "YFileName::IsFullName() : null path";
	if(path)
	{
		const int k=::strlen(path);
		for(int i=k; i>0; i--)
		{
			char c=path[i];
			if(c=='.')
			{//FOUND !
				return path+i;
			}
			else if(c=='\\' ||c==32 || c=='/' ||c==':')
				break;
		}
	}
	return "";
}
//static
char * YFileName::ChangeExt(const char* path,const char *ext,char *new_path)
{
	if(!path || !new_path)
		throw "YFileName::IsFullName() : null path";
	int pt_pos=-1;
	int bs_pos=-1;
	int i=0;
	while(1)
	{
		char c=path[i];
		switch(c)
		{
		case '.':
			pt_pos=i;
			break;
		case '/':
			c='\\';
		case '\\':
			bs_pos=i;
			break;
		};
		new_path[i]=c;
		if(c==0)
			break;
		i++;
	}
	if(bs_pos<pt_pos)
		new_path[pt_pos]=0;
	if(ext)
		::strcat(new_path,ext);
	return new_path;
}
//static
char * YFileName::GetDrDir(const char* path,char *drdir)
{     //drdir="X:\\dir1\\dir2\\"
	if(!path || !drdir)
		throw "YFileName::GetDrDir() : null path";
	int bs_pos=-1;
	int i=0;
	while(1)
	{
		char c=path[i];
		switch(c)
		{
		case '/':
			c='\\';
		case '\\':
			bs_pos=i;
			break;
		};
		drdir[i]=c;
		if(c==0)
			break;
		i++;
	}
	if(bs_pos>0)
		drdir[bs_pos+1]=0;
	return drdir;
}
//static
const char * YFileName::GetNameExt(const char* path)
{ //name_ext="asd.tif"
	if(!path )
		throw "YFileName::GetNameExt() : null path";
	int bs_pos=-1;
	int i=0;
	while(1)
	{
		char c=path[i];
		if(c=='/' || c=='\\')
			bs_pos=i;
		else if(c==0)
			break;
		i++;
	}
	bs_pos++;
	return path+bs_pos;
}
//static 
char * YFileName::GetName(const char* path,char *name)
{//name="My file name"
	if(!path || !name)
		throw "YFileName::GetNameExt() : null path";
	int bs_pos=-1;
	int pt_pos=-1;
	int i=0;
	while(1)
	{
		char c=path[i];
		if(c=='/' || c=='\\')
			bs_pos=i;
		else if(c=='.')
			pt_pos=i;
		else if(c==0)
			break;
		i++;
	}
	bs_pos++;
	if(pt_pos<=bs_pos)
		::strcpy(name,path+bs_pos);
	else
	{
		::strncpy(name,path+bs_pos,pt_pos-bs_pos);
		name[pt_pos-bs_pos]=0;
	}
	return name;
}
*/