//#pragma warning( disable : 4786 )

//#include <string.h>

//#include <stdlib.h>

//#include <sys\types.h> //struct stat
//#include <sys\stat.h> //stat()
#include <iostream>
#include <string>
//#include <list>
//#include <algorithm>
//#include <memory>//auto_ptr

//Next 3 lines order is important,because "xml_interface.h" includes "xml_interface_imp.h" not complite, only some defines without driver functions. 
#define YXML_DRIVER_USING
#include "xml_interface_imp.h"
#include "xml_interface.h"
#include "ywin.h"
#include "yfilesys.h"

////////////////////////////////////////////////////////////////////
#ifdef YXML_DRIVER_USING
	static DllModule yxml_drv;
	static _YXML_DRV_ReleaseCString YXML_DRV_ReleaseCString=0;
	static _YXML_DRV_InitializeXercesc YXML_DRV_InitializeXercesc=0;
	static _YXML_DRV_OpenClose YXML_DRV_OpenClose=0;
	static _YXML_DRV_GetRootNode YXML_DRV_GetRootNode=0;
	static _YXML_DRV_TreeWalk YXML_DRV_TreeWalk=0;
	static _YXML_DRV_NodeType YXML_DRV_NodeType=0;
	static _YXML_DRV_Insert YXML_DRV_Insert=0;
	static _YXML_DRV_NodeGetSet YXML_DRV_NodeGetSet=0;
#endif
////////////////////////////////////////////////////////////////////

static const char* EncodingSystem="windows-1251";
////////////////////////////////////////////////////////////////////
	class _DRV_Except
	{
	public:
		YXML_DRV_DomCString  msg;
		_DRV_Except() : msg(0) {}
		~_DRV_Except() {if(msg) YXML_DRV_ReleaseCString(&msg);}
		void check() {if(msg) throw std::string(msg); }
	};

	class _StrX
	{
			YXML_DRV_DomCString  cstr;
	public :
		_StrX(YXML_DRV_DomCString s) : cstr(s) {}
		~_StrX() { if(cstr) YXML_DRV_ReleaseCString(&cstr); }
		std::string string() const  { return std::string(cstr?cstr:"");  }
		::DataString DataString() const  { return ::DataString(cstr?cstr:"");  }
	};

////////////////////////////////////////////////////////////////////
using namespace YXML;
////////////////////////////////////////////////////////////////////
int Xercesc::reference_counter=0;
Xercesc::Xercesc()
{
#ifdef YXML_DRIVER_USING
	if(reference_counter==0)
	{
		yxml_drv.LoadLibrary("yxml_drv.dll");
		if(!yxml_drv.IsOk())
			throw std::string("Can't load library");

		YXML_DRV_ReleaseCString=(_YXML_DRV_ReleaseCString)yxml_drv.GetProcAddress("YXML_DRV_ReleaseCString");
		YXML_DRV_InitializeXercesc=(_YXML_DRV_InitializeXercesc)yxml_drv.GetProcAddress("YXML_DRV_InitializeXercesc");
		YXML_DRV_OpenClose=(_YXML_DRV_OpenClose)yxml_drv.GetProcAddress("YXML_DRV_OpenClose");
		YXML_DRV_GetRootNode=(_YXML_DRV_GetRootNode)yxml_drv.GetProcAddress("YXML_DRV_GetRootNode");
		YXML_DRV_TreeWalk=(_YXML_DRV_TreeWalk)yxml_drv.GetProcAddress("YXML_DRV_TreeWalk");
		YXML_DRV_NodeType=(_YXML_DRV_NodeType)yxml_drv.GetProcAddress("YXML_DRV_NodeType");
		YXML_DRV_Insert=(_YXML_DRV_Insert)yxml_drv.GetProcAddress("YXML_DRV_Insert");
		YXML_DRV_NodeGetSet=(_YXML_DRV_NodeGetSet)yxml_drv.GetProcAddress("YXML_DRV_NodeGetSet");

		if(	
				 (YXML_DRV_ReleaseCString==0) 
			|| (YXML_DRV_InitializeXercesc==0)
			|| (YXML_DRV_OpenClose==0)
			|| (YXML_DRV_GetRootNode==0)
			|| (YXML_DRV_TreeWalk==0)
			|| (YXML_DRV_NodeType==0)
			|| (YXML_DRV_Insert==0)
			|| (YXML_DRV_NodeGetSet==0)
			) throw std::string("Xercesc::Xercesc : not all functions in driver");
	}
#endif
	_DRV_Except except;
	reference_counter=YXML_DRV_InitializeXercesc(true,EncodingSystem,&except.msg);
	except.check();
}
Xercesc::~Xercesc()
{
	_DRV_Except except;
	reference_counter=YXML_DRV_InitializeXercesc(false,0,&except.msg);
	except.check();

#ifdef YXML_DRIVER_USING
	if(reference_counter==0)
	{
		YXML_DRV_ReleaseCString=0;
		YXML_DRV_InitializeXercesc=0;
		YXML_DRV_OpenClose=0;
		YXML_DRV_GetRootNode=0;
		YXML_DRV_TreeWalk=0;
		YXML_DRV_NodeType=0;
		YXML_DRV_Insert=0;
		YXML_DRV_NodeGetSet=0;

		yxml_drv.FreeLibrary();
	}
#endif
}
////////////////////////////////////////////////////////////////////
XMLdoc::XMLdoc() 
:handle(0),_autosave(false) 
{
}
XMLdoc::XMLdoc(const char *fname,const char* docname,bool autosave)
:handle(0), filename(fname), _autosave(autosave)
{
	{
		const char* XercescMsg="XERCESC_NLS_HOME";
//		const char *e=getenv(XercescMsg);
		std::string e=YFileSys::getEnv(XercescMsg);
		if(e.empty())
		{
			throw "You should set environment variable XERCESC_NLS_HOME to path to file XercesMessages_en_US.res. For example XERCESC_NLS_HOME=d:/dll";
/*//In OCX no __argv exist
			char env[512];
			sprintf(env,"%s=%s",XercescMsg,__argv[0]);
			int i=strlen(env);
			while(--i)
				if(env[i]=='\\' || env[i]=='/')
					break;
			env[i]=0;
			putenv(env);
*/
		}
	}
	if(IsFileExist(fname))
	{
		Load(fname,true);
		if(Root().getName()!=docname)
			throw std::string("XMLdoc: Attempt use another XML document");
	}
	else
		Create(fname,docname);
}
XMLdoc::~XMLdoc() 
{
	if(handle)
	{
		if(_autosave)
			Save(filename.c_str(),true);
		_DRV_Except except;
		int status=YXML_DRV_OpenClose(&handle,YXML_DOC_DO_FREE,0,0,0,&except.msg);
		except.check();
	}
}

//static 
bool XMLdoc::IsFileExist(const char *fname)
{
	return YFileSys::isFileExist(fname);
//	struct stat buffer;
//	return (0==::stat(fname,&buffer))?true:false;
}
void XMLdoc::Create(const char *fname,const char *docname)
{
	//"cp866"; // DOS
	unsigned flags=0;
	_DRV_Except except;
	int status=YXML_DRV_OpenClose(&handle,YXML_DOC_DO_CREATE|flags,fname,docname,"windows-1251",&except.msg);
	except.check();
	filename=fname;
}
void XMLdoc::Load(const char *fname,bool condenseWS)
{
	_DRV_Except except;
	unsigned flags=0;
	flags|=(condenseWS)?YXML_DOC_OPT_EAT_WS:0;
	int status=YXML_DRV_OpenClose(&handle,YXML_DOC_DO_LOAD|flags,fname,0,0,&except.msg);
	filename=fname;
	except.check();
}
void XMLdoc::Save(const char *fname,bool formatted) const
{
	_DRV_Except except;
	filename=fname;
	unsigned flags=0;
	flags|=(formatted)?YXML_DOC_OPT_FORMATTED_OUTPUT:0;
	int status=YXML_DRV_OpenClose((YXML_DRV_DocHandle*)&handle,YXML_DOC_DO_SAVE|flags,fname,0,0,&except.msg);
	except.check();
}
DNode XMLdoc::Root()
{
	_DRV_Except except;
	YXML_DRV_NodeHandle n=YXML_DRV_GetRootNode(handle,&except.msg);
	except.check();
	return DNode(n);
}
////////////////////////////////////////////////////////////////////
DNode DNode::Parent() const
{
	_DRV_Except except;
	YXML_DRV_NodeHandle n=YXML_DRV_TreeWalk(node,YXML_DRV_WALK_PARENT,&except.msg);
	except.check();
	return DNode(n);
}

DNode DNode::FirstChild() const
{
	_DRV_Except except;
	YXML_DRV_NodeHandle n=YXML_DRV_TreeWalk(node,YXML_DRV_WALK_CHILD_FIRST,&except.msg);
	except.check();
	return DNode(n);
}
DNode DNode::LastChild() const
{
	_DRV_Except except;
	YXML_DRV_NodeHandle n=YXML_DRV_TreeWalk(node,YXML_DRV_WALK_CHILD_LAST,&except.msg);
	except.check();
	return DNode(n);
}
DNode DNode::Next() const
{
	_DRV_Except except;
	YXML_DRV_NodeHandle n=YXML_DRV_TreeWalk(node,YXML_DRV_WALK_SIBLING_NEXT,&except.msg);
	except.check();
	return DNode(n);
}
DNode DNode::Prev() const
{
	_DRV_Except except;
	YXML_DRV_NodeHandle n=YXML_DRV_TreeWalk(node,YXML_DRV_WALK_SIBLING_PREV,&except.msg);
	except.check();
	return DNode(n);
}
////////////////////////////////////////////////////////////////////
DNode::Type DNode::getType() const 
{ 
	if(!node)
		throw std::string("DNode::getType(): null node");
	_DRV_Except except;
	unsigned t=YXML_DRV_NodeType(node,&except.msg);
	except.check();
	return DNode::Type(t);
}

std::string DNode::getName() const
{
	_DRV_Except except;
	_StrX s(YXML_DRV_NodeGetSet(node,YXML_DRV_NODE_GET_NAME,0,0,&except.msg));
	except.check();
	return s.string();
}

DataString DNode::getValue() const
{
	_DRV_Except except;
	_StrX s(YXML_DRV_NodeGetSet(node,YXML_DRV_NODE_GET_VALUE,0,0,&except.msg));
	except.check();
	return s.DataString();
}
void DNode::setValue(const DataString data)
{
	_DRV_Except except;
	//if(DOMNode::TEXT_NODE==NODE->getNodeType())
		YXML_DRV_NodeGetSet(node,YXML_DRV_NODE_SET_VALUE,0,data.c_str(),&except.msg);
	except.check();
}

DataString DNode::GetAttr(const std::string attr_name) const
{
		if(!node )
			return DataString("");
		else
		{
			_DRV_Except except;
			_StrX s(YXML_DRV_NodeGetSet(node,YXML_DRV_NODE_GET_ATTR,attr_name.c_str(),0,&except.msg));
			except.check();
			return s.DataString();
		}
}

void DNode::SetAttr(const std::string attr_name,const DataString attr_value)
{
	if(ELEMENT!=getType())
		throw std::string("Only Element node can have attributes");
	else
	{
		_DRV_Except except;
		YXML_DRV_NodeGetSet(node,YXML_DRV_NODE_SET_ATTR,attr_name.c_str(),attr_value.c_str(),&except.msg);
		except.check();
	}
}
////////////////////////////////////////////////////////////////////
DNode DNode::AppendChild(Type type,const DataString data)
{
	YXML_DRV_NodeHandle n=0;
	if(ELEMENT!=getType())
		throw std::string("Child may appended only to ELEMENT node");
	else
	{
		_DRV_Except except;
		n=YXML_DRV_Insert(node,YXML_DRV_INSERT_APPEND_CHILD,type,data.c_str(),&except.msg);
		except.check();
	}
	return DNode(n);
}
DNode DNode::InsertAfter(Type type,const DataString data)
{
	YXML_DRV_NodeHandle n=0;
	if(ELEMENT!=getType())
		throw std::string("Child may appended only to ELEMENT node");
	else
	{
		_DRV_Except except;
		n=YXML_DRV_Insert(node,YXML_DRV_INSERT_AFTER,type,data.c_str(),&except.msg);
		except.check();
	}
	return DNode(n);
}
DNode DNode::InsertBefore(Type type,const DataString data)
{
	YXML_DRV_NodeHandle n=0;
	if(ELEMENT!=getType())
		throw std::string("Child may appended only to ELEMENT node");
	else
	{
		_DRV_Except except;
		n=YXML_DRV_Insert(node,YXML_DRV_INSERT_BEFORE,type,data.c_str(),&except.msg);
		except.check();
	}
	return DNode(n);
}
void DNode::Delete()
{
		_DRV_Except except;
		node=YXML_DRV_Insert(node,YXML_DRV_INSERT_DELETE,YXML_DRV_NODETYPE_UNSUPPORTED,0,&except.msg);
		except.check();
}
////////////////////////////////////////////////////////////////////
DNode DNode::GetNode(const std::string node_name)
{
	DNode n=FirstChild(node_name);
	if(n.IsNode())
		return n;
	else
		return AppendChild(ELEMENT,node_name.c_str());
}

void DNode::SetValue(const DataString data) 
{
	if(ELEMENT!=getType())
		throw std::string("Text context may be added only to ELEMENT node");
	DNode n=FirstChild();
	while(n.IsNode())
	{
		if(TEXT==n.getType())
		{
			n.setValue(data);
			return;
		}
		n=n.Next();
	}
	AppendChild(TEXT,data);
}
DataString DNode::GetValue() const
{
	if(ELEMENT!=getType())
		throw std::string("Text context may be added only to ELEMENT node");
	DNode n=FirstChild();
	while(n.IsNode())
	{
		if(TEXT==n.getType())
			return n.getValue();
		n=n.Next();
	}
	return DataString("");
}

DNode DNode::FirstChild(const DNode::Is& cond) const
{
	DNode n=FirstChild();
	while(n.IsNode())
	{
		if(cond(n))
				return n;
		n=n.Next();
	}
	return DNode(0);
}
DNode DNode::LastChild(const DNode::Is& cond) const
{
	DNode n=LastChild();
	while(n.IsNode())
	{
		if(cond(n))
				return n;
		n=n.Prev();
	}
	return DNode(0);
}
DNode DNode::Next(const DNode::Is& cond) const
{
	DNode n(node);
	n=n.Next();
	while(n.IsNode())
	{
		if(cond(n))
				return n;
		n=n.Next();
	}
	return DNode(0);
}
DNode DNode::Prev(const DNode::Is& cond) const
{
	DNode n(node);
	n=n.Prev();
	while(n.IsNode())
	{
		if(cond(n))
				return n;
		n=n.Prev();
	}
	return DNode(0);
}
