#ifndef _YTYPES_H
#define _YTYPES_H
/////////////////////////////////////////////////////////////////////////
/** @addtogroup  GeneralGroup    (, , , ). 
 * @{
 */
#ifdef __BORLANDC__
	#include <system.hpp>
	#include <stdint.h>
#elif _MSC_VER
	#ifndef __STDC_LIMIT_MACROS
		#define __STDC_LIMIT_MACROS
	#endif //__STDC_LIMIT_MACROS
	#if _MSC_VER >= 1400
		#include <limits.h>
	#endif
	typedef unsigned char        Byte;
	#include "stdint.h"
#elif __GNUC__
	typedef unsigned char        Byte;
	#include <stdint.h>
#else
	#error "Unknown compiler"
#endif
#ifdef __DEPRECATED__
typedef   signed char         int1;   // 1-byte ,   signed integer
typedef unsigned short int   uint2;  // 2-byte , unsigned integer
typedef   signed short int    int2;  // 2-byte ,   signed integer
typedef unsigned       int   uint4;  // 4-byte , unsigned integer
typedef   signed       int    int4;  // 4-byte ,   signed integer
typedef unsigned     __int64 uint8;  // 8-byte , unsigned integer
typedef   signed     __int64  int8;  // 8-byte ,   signed integer
#endif //__DEPRECATED__
//--------General macros:
#ifndef MAX
	#define MAX(a,b) ( ((a)>(b)) ? (a) : (b) )
#endif
#ifndef MIN
	#define MIN(a,b) ( ((a)<(b)) ? (a) : (b) )
#endif
#ifndef MAX3
	#define MAX3(a,b,c) MAX(MAX(a,b),c)
#endif
#ifndef MAX4
	#define MAX4(a,b,c,d) MAX(MAX(a,b),MAX(c,d))
#endif
#ifndef MIN3
	#define MIN3(a,b,c) MIN(MIN(a,b),c)
#endif
#ifndef MIN4
	#define MIN4(a,b,c,d) MIN(MIN(a,b),MIN(c,d))
#endif
#ifndef ABS
	#define ABS(a) (((a)<0)?-(a):(a))
#endif
#ifndef IN_BOUNDS
	#define IN_BOUNDS(var,min,max)  (((var)<(min))?(min):(((var)>(max))?(max):(var)))
#endif
//------FORTRAN definitions:
#ifndef SIGN
	#define SIGN(X1,X2) ((X2 >= 0) ? ABS(X1) : -ABS(X1))
#endif
/** @} */ // end of GeneralGroup 
/////////////////////////////////////////////////////////////////////////
#endif //_YTYPES_H
