#include <windows.h>
#include <assert.h>
#include "ywinini.h"


WiNode WiNode::GetNode(const std::string node_name)
{
	//check forbidden symbols
	assert(!node_name.empty());
	assert(node_name.find_first_of("[]=<>?/\\",node_name.size()+1) > node_name.size());
        std::string s=name.empty() ? node_name : (name+'\\'+node_name);//local variable need by BCB 6.0 
	return WiNode(fname,s);
}

const WiNode WiNode::GetNode(const std::string node_name) const
{
	//check forbidden symbols
	assert(!node_name.empty());
	assert(node_name.find_first_of("[]=<>?/\\",node_name.size()+1) > node_name.size());
        std::string s=name.empty() ? node_name : (name+'\\'+node_name);//local variable need by BCB 6.0 
	return WiNode(fname,s);
}

void WiNode::SetAttr(const std::string attr_name,const DataString attr_value)
{
	::WritePrivateProfileString(name.c_str(),attr_name.c_str(),attr_value.c_str(),fname.c_str());
}
DataString WiNode::GetAttr(const std::string attr_name) const
{
	char buf[1024];
	buf[sizeof(buf)-1]=0;
	::GetPrivateProfileString(name.c_str(),attr_name.c_str(),"",buf,sizeof(buf)-1,fname.c_str());
	return DataString(buf);
}

static const std::string DefaultItemName("#text");

void WiNode::SetValue(const DataString data)
{
	this->SetAttr(DefaultItemName,data);
}

DataString WiNode::GetValue() const
{
	return this->GetAttr(DefaultItemName);
}

WinIniFile::WinIniFile(std::string filename) 
:fname(filename)
{
}
void WinIniFile::Load(std::string filename)
{//connect to new (another) ini file
	fname=filename;
}
WiNode WinIniFile::Root() const
{
	return WiNode(fname,"");
}
