#ifndef _PBM_FILE_H
#define _PBM_FILE_H
////////////////////////////////////////////////////////////////////////
#include "yfile.h"
namespace IFF
{
class PBMfile
:public YFile
{
	int width;
	int height;
	int bits;
	int type;
	unsigned data_offset;
private:
	void nullify();
	void writeHeader();
	void readHeader();
public:
	enum TYPE
	{
		//PBM_BILEVEL,
		PBM_GRAYSCALE,
		PBM_RGB,
		PBM_UNKNOWN=0xFFFF
	};
	PBMfile();
	virtual ~PBMfile();
	void open(const char *fname,OpenMode access,
				int  Width=0,int  Heigth=0,int  bitsPerPixel=8,TYPE _type=PBM_GRAYSCALE);
	void close();
	bool IsOk() const {return type>=0; }
	//--------------------------------------------------
	void read(int x,int y,Byte *line,int len);
	void write(int x,int y,const Byte *line,int len);
	//------------------------------------------------
	int Width()  const { return width; }
	int Length() const { return height; }
	int Bits()   const { return bits; }
	TYPE Type() const;
	//--------------------------------------------------
};
} //namespace IFF
////////////////////////////////////////////////////////////////////////
#endif//_PBM_FILE_H
