#ifndef _VIRTDIB_H
#define _VIRTDIB_H
/////////////////////////////////////////////////////////////////////////////
#include "zoomfact.h" //->this file includes <windows.h>
#include "aimage.h"
/////////////////////////////////////////////////////////////////////////////
class VirtDib
{
	enum Type
	{
		BMT_GRAY8,
		BMT_PAL8,
		BMT_RGB8
	};
	struct Inf
	{
		short width;
		short height;
		short bits;
		short pal_entries;
		int bytes_per_row;
	};
	BYTE *data;
	BITMAPINFO * info;
  short pal_entries;
	int   bytes_per_row;
  long * line_buffer;
	unsigned data_sz;
	unsigned line_buffer_sz;
	Inf inf8pal;
	Inf inf8rgb;
	Type  last_type;
private:
	long BytesPerRow(short width,short bits);
//	void bmiHeaderInit(int width,int height,int bits,int bytes_per_row);
	void bmiHeaderInit(const Inf& param);
public:
//SetDIBitsToDevice() correctly works ONLY when (width % 4) = 0 !!!
//	VirtDib(short width=512,short height=64,short bits=8);
	VirtDib();
	~VirtDib();
	short Width()  { return (info)? short(info->bmiHeader.biWidth) : short(0); }
	short Height() { return (info)? short(info->bmiHeader.biHeight) : short(0); }
//  void Load(const char *fname);
//  void Save(const char *fname);
	BYTE* operator[](int y) { return (info)? data+long(bytes_per_row)*(info->bmiHeader.biHeight-1-y) : 0;}
	int GetPaletteEntries() const { return pal_entries; }
	RGBQUAD* GetPalette() { return (info)? info->bmiColors : (RGBQUAD*)(0);}
	void SetGrayPalette();
	void SetImagePalette(const AImageMem8* img8);
//	void OptimizeSize(short width,short height);
//  void OptimizeSize(TRect rect);
//	void Build(AImageMem16& img,TRect& portion,BYTE *map_table);
	void Build(const AImageMem8& img,const RECT& portion,const ZoomFactor2D zoom,const BYTE *map_table);
	void BuildViaDecimation(const AImageMem8& img,const RECT& portion,const ZoomFactor2D zoom,const BYTE *map_table);
	void Build(const AImageMem16& img,const RECT& portion,const ZoomFactor2D zoom,const BYTE *map_table);
	void Build(const AImageMemRgb8& img,const RECT& portion,const ZoomFactor2D zoom,const BYTE *map_table);
	void Paint(HDC hdc,const RECT& rect);
	void DefaultPaint(HWND hWnd,HDC hdc,HBRUSH hBrush,const AImage *img,const ZoomFactor2D& zoom,const BYTE *map_table=0);
};

/////////////////////////////////////////////////////////////////////////////
#endif// _VIRTDIB_H
