#ifndef _NUM_LINALG_H
#define _NUM_LINALG_H
////////////////////////////////////////////////////////////////////////////////////////////////
#include <algorithm>
#define _USE_MATH_DEFINES
#include <cmath>
////////////////////////////////////////////////////////////////////////////////////////////////
#include <boost/numeric/ublas/vector.hpp>
#include <boost/numeric/ublas/matrix.hpp>
#include <boost/numeric/ublas/matrix_proxy.hpp>
#include <boost/numeric/ublas/symmetric.hpp>
#include <boost/numeric/ublas/io.hpp>
#include <boost/numeric/ublas/lu.hpp>
#include <boost/numeric/ublas/blas.hpp>
////////////////////////////////////////////////////////////////////////////////////////////////
#include "vtl_meta_base.h"
#include "numalg.h"
////////////////////////////////////////////////////////////////////////////////////////////////
namespace Vtl
{
namespace NumAlg
{
/*!
 * \brief    , alias    boost::numeric::ublas 
 *                  BLAS - 
 *         Basic Linear Algebra Subprograms http://www.netlib.org/blas/.
 *
 **********************************************************************************************/
namespace Lin
{ 
///intruduce boost namespaces into Vtl::NumAlg::Lin
namespace ublas = boost::numeric::ublas;

////////////////////////////////////////////////////////////////////////////////////////////////
}//namespace Lin
}//namespace NumAlg
}//namespace Vtl
////////////////////////////////////////////////////////////////////////////////////////////////
#include "_num_boost_adds.h"
#include "_num_implicit.h"
////////////////////////////////////////////////////////////////////////////////////////////////
#include "_num_svd.h"
#include "_num_eigen.h"
#include "_num_cholesky.h"
#include "_num_qr.h"
///////////////////////////////////////////////////////////////////////////////////////////////
#endif //_NUM_LINALG_H
